submodule: make 'checkout' update_module mode more explicit
[git/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
4c8a9db6 3# git-submodule.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
681b036f 8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 10 or: $dashless [--quiet] init [--] [<path>...]
cf419828 11 or: $dashless [--quiet] deinit [-f|--force] [--] <path>...
06b1abb5 12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
adc54235 13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 14 or: $dashless [--quiet] foreach [--recursive] <command>
82f49f29 15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
8f321a39 16OPTIONS_SPEC=
091a6eb0 17SUBDIRECTORY_OK=Yes
70c7ac22 18. git-sh-setup
d0ad8251 19. git-sh-i18n
98fcf840 20. git-parse-remote
70c7ac22 21require_work_tree
091a6eb0
JK
22wt_prefix=$(git rev-parse --show-prefix)
23cd_to_toplevel
70c7ac22 24
5c08dbbd 25command=
ecda0723 26branch=
d27b876b 27force=
d92a3959 28reference=
70c7ac22 29cached=
48bb3033
GP
30recursive=
31init=
1c244f6e 32files=
06b1abb5 33remote=
31ca3ac3 34nofetch=
32948425 35update=
15fc56a8 36prefix=
73b0898d 37custom_name=
275cd184 38depth=
70c7ac22 39
967b2c66
JS
40# The function takes at most 2 arguments. The first argument is the
41# URL that navigates to the submodule origin repo. When relative, this URL
42# is relative to the superproject origin URL repo. The second up_path
43# argument, if specified, is the relative path that navigates
44# from the submodule working tree to the superproject working tree.
45#
46# The output of the function is the origin URL of the submodule.
47#
48# The output will either be an absolute URL or filesystem path (if the
49# superproject origin URL is an absolute URL or filesystem path,
50# respectively) or a relative file system path (if the superproject
51# origin URL is a relative file system path).
52#
53# When the output is a relative file system path, the path is either
54# relative to the submodule working tree, if up_path is specified, or to
55# the superproject working tree otherwise.
f31a522a
ML
56resolve_relative_url ()
57{
98fcf840 58 remote=$(get_default_remote)
8e7e6f39 59 remoteurl=$(git config "remote.$remote.url") ||
4d689320 60 remoteurl=$(pwd) # the repository is its own authoritative upstream
f31a522a 61 url="$1"
99b120af 62 remoteurl=${remoteurl%/}
ea640cc6 63 sep=/
967b2c66
JS
64 up_path="$2"
65
66 case "$remoteurl" in
67 *:*|/*)
68 is_relative=
69 ;;
758615e2
JS
70 ./*|../*)
71 is_relative=t
72 ;;
967b2c66
JS
73 *)
74 is_relative=t
758615e2 75 remoteurl="./$remoteurl"
967b2c66
JS
76 ;;
77 esac
78
f31a522a
ML
79 while test -n "$url"
80 do
81 case "$url" in
82 ../*)
83 url="${url#../}"
ea640cc6
TR
84 case "$remoteurl" in
85 */*)
86 remoteurl="${remoteurl%/*}"
87 ;;
88 *:*)
89 remoteurl="${remoteurl%:*}"
90 sep=:
91 ;;
92 *)
758615e2
JS
93 if test -z "$is_relative" || test "." = "$remoteurl"
94 then
95 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
96 else
97 remoteurl=.
98 fi
ea640cc6
TR
99 ;;
100 esac
f31a522a
ML
101 ;;
102 ./*)
103 url="${url#./}"
104 ;;
105 *)
106 break;;
107 esac
108 done
758615e2
JS
109 remoteurl="$remoteurl$sep${url%/}"
110 echo "${is_relative:+${up_path}}${remoteurl#./}"
f31a522a
ML
111}
112
091a6eb0
JK
113# Resolve a path to be relative to another path. This is intended for
114# converting submodule paths when git-submodule is run in a subdirectory
115# and only handles paths where the directory separator is '/'.
116#
117# The output is the first argument as a path relative to the second argument,
118# which defaults to $wt_prefix if it is omitted.
119relative_path ()
120{
121 local target curdir result
122 target=$1
123 curdir=${2-$wt_prefix}
124 curdir=${curdir%/}
125 result=
126
127 while test -n "$curdir"
128 do
129 case "$target" in
130 "$curdir/"*)
131 target=${target#"$curdir"/}
132 break
133 ;;
134 esac
135
136 result="${result}../"
137 if test "$curdir" = "${curdir%/*}"
138 then
139 curdir=
140 else
141 curdir="${curdir%/*}"
142 fi
143 done
144
145 echo "$result$target"
146}
147
a7b3269c
DA
148#
149# Get submodule info for registered submodules
150# $@ = path to limit submodule list
151#
152module_list()
153{
091a6eb0 154 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
be9d0a3a 155 (
74671241 156 git ls-files -z --error-unmatch --stage -- "$@" ||
be9d0a3a
HV
157 echo "unmatched pathspec exists"
158 ) |
313ee0d6
NMC
159 perl -e '
160 my %unmerged = ();
161 my ($null_sha1) = ("0" x 40);
be9d0a3a
HV
162 my @out = ();
163 my $unmatched = 0;
74671241 164 $/ = "\0";
313ee0d6 165 while (<STDIN>) {
be9d0a3a
HV
166 if (/^unmatched pathspec/) {
167 $unmatched = 1;
168 next;
169 }
313ee0d6
NMC
170 chomp;
171 my ($mode, $sha1, $stage, $path) =
172 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
173 next unless $mode eq "160000";
174 if ($stage ne "0") {
175 if (!$unmerged{$path}++) {
be9d0a3a 176 push @out, "$mode $null_sha1 U\t$path\n";
313ee0d6
NMC
177 }
178 next;
179 }
be9d0a3a
HV
180 push @out, "$_\n";
181 }
182 if ($unmatched) {
183 print "#unmatched\n";
184 } else {
185 print for (@out);
313ee0d6
NMC
186 }
187 '
a7b3269c
DA
188}
189
be9d0a3a
HV
190die_if_unmatched ()
191{
192 if test "$1" = "#unmatched"
193 then
194 exit 1
195 fi
196}
197
88ce00c3
TK
198#
199# Print a submodule configuration setting
200#
201# $1 = submodule name
202# $2 = option name
203# $3 = default value
204#
205# Checks in the usual git-config places first (for overrides),
206# otherwise it falls back on .gitmodules. This allows you to
207# distribute project-wide defaults in .gitmodules, while still
208# customizing individual repositories if necessary. If the option is
209# not in .gitmodules either, print a default value.
210#
211get_submodule_config () {
212 name="$1"
213 option="$2"
214 default="$3"
215 value=$(git config submodule."$name"."$option")
216 if test -z "$value"
217 then
218 value=$(git config -f .gitmodules submodule."$name"."$option")
219 fi
220 printf '%s' "${value:-$default}"
221}
222
223
941987a5
LH
224#
225# Map submodule path to submodule name
226#
227# $1 = path
228#
229module_name()
230{
537601ac 231 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
64394e3a 232 sm_path="$1"
fe22e542 233 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
a5099bb4 234 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
537601ac 235 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
1e42258a 236 test -z "$name" &&
64394e3a 237 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$sm_path'")"
1e42258a 238 echo "$name"
941987a5 239}
33aa6fff
LH
240
241#
242# Clone a submodule
243#
23a485e3 244# Prior to calling, cmd_update checks that a possibly existing
ecda0723 245# path is not a git repository.
23a485e3 246# Likewise, cmd_add checks that path does not exist at all,
ecda0723
SV
247# since it is the location of a new submodule.
248#
33aa6fff
LH
249module_clone()
250{
64394e3a 251 sm_path=$1
73b0898d
JL
252 name=$2
253 url=$3
254 reference="$4"
275cd184 255 depth="$5"
7e60407f
JL
256 quiet=
257 if test -n "$GIT_QUIET"
258 then
259 quiet=-q
260 fi
33aa6fff 261
501770e1
FG
262 gitdir=
263 gitdir_base=
69c30517 264 base_name=$(dirname "$name")
33aa6fff 265
501770e1 266 gitdir=$(git rev-parse --git-dir)
69c30517
JL
267 gitdir_base="$gitdir/modules/$base_name"
268 gitdir="$gitdir/modules/$name"
501770e1
FG
269
270 if test -d "$gitdir"
d92a3959 271 then
64394e3a 272 mkdir -p "$sm_path"
501770e1 273 rm -f "$gitdir/index"
d92a3959 274 else
501770e1 275 mkdir -p "$gitdir_base"
be8779f7
DG
276 (
277 clear_local_git_env
275cd184 278 git clone $quiet ${depth:+"$depth"} -n ${reference:+"$reference"} \
be8779f7
DG
279 --separate-git-dir "$gitdir" "$url" "$sm_path"
280 ) ||
64394e3a 281 die "$(eval_gettext "Clone of '\$url' into submodule path '\$sm_path' failed")"
501770e1 282 fi
ea115a0d 283
6eafa6d0
JL
284 # We already are at the root of the work tree but cd_to_toplevel will
285 # resolve any symlinks that might be present in $PWD
286 a=$(cd_to_toplevel && cd "$gitdir" && pwd)/
15b3c82c 287 b=$(cd_to_toplevel && cd "$sm_path" && pwd)/
4dce7d9b
JS
288 # normalize Windows-style absolute paths to POSIX-style absolute paths
289 case $a in [a-zA-Z]:/*) a=/${a%%:*}${a#*:} ;; esac
290 case $b in [a-zA-Z]:/*) b=/${b%%:*}${b#*:} ;; esac
d75219b4
JL
291 # Remove all common leading directories after a sanity check
292 if test "${a#$b}" != "$a" || test "${b#$a}" != "$b"; then
293 die "$(eval_gettext "Gitdir '\$a' is part of the submodule path '\$b' or vice versa")"
294 fi
295 while test "${a%%/*}" = "${b%%/*}"
296 do
297 a=${a#*/}
298 b=${b#*/}
299 done
300 # Now chop off the trailing '/'s that were added in the beginning
301 a=${a%/}
302 b=${b%/}
303
c5bc42b9
BW
304 # Turn each leading "*/" component into "../"
305 rel=$(echo $b | sed -e 's|[^/][^/]*|..|g')
64394e3a 306 echo "gitdir: $rel/$a" >"$sm_path/.git"
69c30517 307
c5bc42b9 308 rel=$(echo $a | sed -e 's|[^/][^/]*|..|g')
64394e3a 309 (clear_local_git_env; cd "$sm_path" && GIT_WORK_TREE=. git config core.worktree "$rel/$b")
33aa6fff
LH
310}
311
862ae6cd
RS
312isnumber()
313{
314 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
315}
316
ecda0723
SV
317#
318# Add a new submodule to the working tree, .gitmodules and the index
319#
ec05df35 320# $@ = repo path
ecda0723
SV
321#
322# optional branch is stored in global branch variable
323#
23a485e3 324cmd_add()
ecda0723 325{
5c08dbbd 326 # parse $args after "submodule ... add".
091a6eb0 327 reference_path=
5c08dbbd
JH
328 while test $# -ne 0
329 do
330 case "$1" in
331 -b | --branch)
332 case "$2" in '') usage ;; esac
333 branch=$2
334 shift
335 ;;
d27b876b
JL
336 -f | --force)
337 force=$1
338 ;;
5c08dbbd 339 -q|--quiet)
2e6a30ef 340 GIT_QUIET=1
5c08dbbd 341 ;;
d92a3959
MT
342 --reference)
343 case "$2" in '') usage ;; esac
091a6eb0 344 reference_path=$2
d92a3959
MT
345 shift
346 ;;
347 --reference=*)
091a6eb0 348 reference_path="${1#--reference=}"
d92a3959 349 ;;
73b0898d
JL
350 --name)
351 case "$2" in '') usage ;; esac
352 custom_name=$2
353 shift
354 ;;
275cd184
FG
355 --depth)
356 case "$2" in '') usage ;; esac
357 depth="--depth=$2"
358 shift
359 ;;
360 --depth=*)
361 depth=$1
362 ;;
5c08dbbd
JH
363 --)
364 shift
365 break
366 ;;
367 -*)
368 usage
369 ;;
370 *)
371 break
372 ;;
373 esac
374 shift
375 done
376
091a6eb0
JK
377 if test -n "$reference_path"
378 then
379 is_absolute_path "$reference_path" ||
380 reference_path="$wt_prefix$reference_path"
381
382 reference="--reference=$reference_path"
383 fi
384
ecda0723 385 repo=$1
64394e3a 386 sm_path=$2
ecda0723 387
64394e3a
RJ
388 if test -z "$sm_path"; then
389 sm_path=$(echo "$repo" |
1414e578
JL
390 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
391 fi
392
64394e3a 393 if test -z "$repo" -o -z "$sm_path"; then
ecda0723
SV
394 usage
395 fi
396
091a6eb0
JK
397 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
398
ec05df35
ML
399 # assure repo is absolute or relative to parent
400 case "$repo" in
401 ./*|../*)
091a6eb0
JK
402 test -z "$wt_prefix" ||
403 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
404
ec05df35
ML
405 # dereference source url relative to parent's url
406 realrepo=$(resolve_relative_url "$repo") || exit
407 ;;
408 *:*|/*)
409 # absolute url
410 realrepo=$repo
411 ;;
412 *)
497ee872 413 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
414 ;;
415 esac
416
db75ada5
MG
417 # normalize path:
418 # multiple //; leading ./; /./; /../; trailing /
64394e3a 419 sm_path=$(printf '%s/\n' "$sm_path" |
db75ada5
MG
420 sed -e '
421 s|//*|/|g
422 s|^\(\./\)*||
423 s|/\./|/|g
424 :start
425 s|\([^/]*\)/\.\./||
426 tstart
427 s|/*$||
428 ')
64394e3a
RJ
429 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
430 die "$(eval_gettext "'\$sm_path' already exists in the index")"
ecda0723 431
64394e3a 432 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
d27b876b 433 then
6ff875c5 434 eval_gettextln "The following path is ignored by one of your .gitignore files:
64394e3a 435\$sm_path
6ff875c5 436Use -f if you really want to add it." >&2
d27b876b
JL
437 exit 1
438 fi
439
73b0898d
JL
440 if test -n "$custom_name"
441 then
442 sm_name="$custom_name"
443 else
444 sm_name="$sm_path"
445 fi
446
d4264ca3 447 # perhaps the path exists and is already a git repo, else clone it
64394e3a 448 if test -e "$sm_path"
d4264ca3 449 then
64394e3a 450 if test -d "$sm_path"/.git -o -f "$sm_path"/.git
d4264ca3 451 then
64394e3a 452 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
d4264ca3 453 else
64394e3a 454 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
d4264ca3 455 fi
c2f93917 456
d4264ca3 457 else
4b7c286e
JL
458 if test -d ".git/modules/$sm_name"
459 then
460 if test -z "$force"
461 then
462 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
463 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
464 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
465 echo >&2 " $realrepo"
466 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
467 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
468 else
469 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
470 fi
471 fi
275cd184 472 module_clone "$sm_path" "$sm_name" "$realrepo" "$reference" "$depth" || exit
ea10b60c 473 (
74ae1419 474 clear_local_git_env
64394e3a 475 cd "$sm_path" &&
ea10b60c
BJ
476 # ash fails to wordsplit ${branch:+-b "$branch"...}
477 case "$branch" in
478 '') git checkout -f -q ;;
502dc5b6 479 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
ea10b60c 480 esac
64394e3a 481 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
d4264ca3 482 fi
73b0898d 483 git config submodule."$sm_name".url "$realrepo"
d4264ca3 484
64394e3a
RJ
485 git add $force "$sm_path" ||
486 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
ecda0723 487
73b0898d
JL
488 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
489 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
b9289227
TK
490 if test -n "$branch"
491 then
492 git config -f .gitmodules submodule."$sm_name".branch "$branch"
493 fi &&
31991b02 494 git add --force .gitmodules ||
64394e3a 495 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
ecda0723
SV
496}
497
19a31f9c
ML
498#
499# Execute an arbitrary command sequence in each checked out
500# submodule
501#
502# $@ = command to execute
503#
504cmd_foreach()
505{
1d5bec8b
JH
506 # parse $args after "submodule ... foreach".
507 while test $# -ne 0
508 do
509 case "$1" in
510 -q|--quiet)
511 GIT_QUIET=1
512 ;;
15fc56a8
JH
513 --recursive)
514 recursive=1
515 ;;
1d5bec8b
JH
516 -*)
517 usage
518 ;;
519 *)
520 break
521 ;;
522 esac
523 shift
524 done
525
f030c96d
ÆAB
526 toplevel=$(pwd)
527
4dca1aa6
BC
528 # dup stdin so that it can be restored when running the external
529 # command in the subshell (and a recursive call to this function)
530 exec 3<&0
531
a7b3269c 532 module_list |
64394e3a 533 while read mode sha1 stage sm_path
19a31f9c 534 do
be9d0a3a 535 die_if_unmatched "$mode"
64394e3a 536 if test -e "$sm_path"/.git
19a31f9c 537 then
091a6eb0
JK
538 displaypath=$(relative_path "$sm_path")
539 say "$(eval_gettext "Entering '\$prefix\$displaypath'")"
64394e3a 540 name=$(module_name "$sm_path")
15fc56a8 541 (
64394e3a 542 prefix="$prefix$sm_path/"
74ae1419 543 clear_local_git_env
64394e3a 544 cd "$sm_path" &&
091a6eb0
JK
545 sm_path=$(relative_path "$sm_path") &&
546 # we make $path available to scripts ...
547 path=$sm_path &&
15fc56a8
JH
548 eval "$@" &&
549 if test -n "$recursive"
550 then
551 cmd_foreach "--recursive" "$@"
552 fi
4dca1aa6 553 ) <&3 3<&- ||
091a6eb0 554 die "$(eval_gettext "Stopping at '\$prefix\$displaypath'; script returned non-zero status.")"
19a31f9c
ML
555 fi
556 done
557}
558
70c7ac22 559#
211b7f19 560# Register submodules in .git/config
70c7ac22
LH
561#
562# $@ = requested paths (default to all)
563#
23a485e3 564cmd_init()
70c7ac22 565{
5c08dbbd
JH
566 # parse $args after "submodule ... init".
567 while test $# -ne 0
568 do
569 case "$1" in
570 -q|--quiet)
2e6a30ef 571 GIT_QUIET=1
5c08dbbd
JH
572 ;;
573 --)
574 shift
575 break
576 ;;
577 -*)
578 usage
579 ;;
580 *)
581 break
582 ;;
583 esac
584 shift
585 done
586
a7b3269c 587 module_list "$@" |
64394e3a 588 while read mode sha1 stage sm_path
70c7ac22 589 do
be9d0a3a 590 die_if_unmatched "$mode"
64394e3a 591 name=$(module_name "$sm_path") || exit
c1c259e2 592
091a6eb0
JK
593 displaypath=$(relative_path "$sm_path")
594
c1c259e2 595 # Copy url setting when it is not set yet
2cd9de3e
JL
596 if test -z "$(git config "submodule.$name.url")"
597 then
598 url=$(git config -f .gitmodules submodule."$name".url)
599 test -z "$url" &&
091a6eb0 600 die "$(eval_gettext "No url found for submodule path '\$displaypath' in .gitmodules")"
2cd9de3e
JL
601
602 # Possibly a url relative to parent
603 case "$url" in
604 ./*|../*)
605 url=$(resolve_relative_url "$url") || exit
606 ;;
607 esac
608 git config submodule."$name".url "$url" ||
091a6eb0 609 die "$(eval_gettext "Failed to register url for submodule path '\$displaypath'")"
c1c259e2 610
091a6eb0 611 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$displaypath'")"
2cd9de3e 612 fi
70c7ac22 613
2cd9de3e 614 # Copy "update" setting when it is not set yet
ac1fbbda
JH
615 if upd="$(git config -f .gitmodules submodule."$name".update)" &&
616 test -n "$upd" &&
617 test -z "$(git config submodule."$name".update)"
618 then
619 case "$upd" in
efa8fd7e 620 checkout | rebase | merge | none)
ac1fbbda
JH
621 ;; # known modes of updating
622 *)
623 echo >&2 "warning: unknown update mode '$upd' suggested for submodule '$name'"
624 upd=none
625 ;;
626 esac
627 git config submodule."$name".update "$upd" ||
628 die "$(eval_gettext "Failed to register update mode for submodule path '\$displaypath'")"
629 fi
70c7ac22
LH
630 done
631}
632
cf419828
JL
633#
634# Unregister submodules from .git/config and remove their work tree
635#
636# $@ = requested paths (use '.' to deinit all submodules)
637#
638cmd_deinit()
639{
640 # parse $args after "submodule ... deinit".
641 while test $# -ne 0
642 do
643 case "$1" in
644 -f|--force)
645 force=$1
646 ;;
647 -q|--quiet)
648 GIT_QUIET=1
649 ;;
650 --)
651 shift
652 break
653 ;;
654 -*)
655 usage
656 ;;
657 *)
658 break
659 ;;
660 esac
661 shift
662 done
663
664 if test $# = 0
665 then
666 die "$(eval_gettext "Use '.' if you really want to deinitialize all submodules")"
667 fi
668
669 module_list "$@" |
670 while read mode sha1 stage sm_path
671 do
672 die_if_unmatched "$mode"
673 name=$(module_name "$sm_path") || exit
674
091a6eb0
JK
675 displaypath=$(relative_path "$sm_path")
676
cf419828
JL
677 # Remove the submodule work tree (unless the user already did it)
678 if test -d "$sm_path"
679 then
680 # Protect submodules containing a .git directory
681 if test -d "$sm_path/.git"
682 then
091a6eb0 683 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
cf419828
JL
684 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
685 fi
686
687 if test -z "$force"
688 then
7b294bf4 689 git rm -qn "$sm_path" ||
091a6eb0 690 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
cf419828 691 fi
7b294bf4 692 rm -rf "$sm_path" &&
091a6eb0
JK
693 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
694 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
cf419828
JL
695 fi
696
091a6eb0 697 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
cf419828
JL
698
699 # Remove the .git/config entries (unless the user already did it)
700 if test -n "$(git config --get-regexp submodule."$name\.")"
701 then
702 # Remove the whole section so we have a clean state when
703 # the user later decides to init this submodule again
704 url=$(git config submodule."$name".url)
705 git config --remove-section submodule."$name" 2>/dev/null &&
091a6eb0 706 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
cf419828
JL
707 fi
708 done
709}
710
70c7ac22 711#
211b7f19 712# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
713#
714# $@ = requested paths (default to all)
715#
23a485e3 716cmd_update()
70c7ac22 717{
5c08dbbd 718 # parse $args after "submodule ... update".
98dbe63d 719 orig_flags=
5c08dbbd
JH
720 while test $# -ne 0
721 do
722 case "$1" in
723 -q|--quiet)
2e6a30ef 724 GIT_QUIET=1
5c08dbbd 725 ;;
be4d2c83 726 -i|--init)
d92a3959 727 init=1
be4d2c83 728 ;;
06b1abb5
TK
729 --remote)
730 remote=1
731 ;;
31ca3ac3 732 -N|--no-fetch)
31ca3ac3
FF
733 nofetch=1
734 ;;
9db31bdf
NMC
735 -f|--force)
736 force=$1
737 ;;
ca2cedba 738 -r|--rebase)
32948425 739 update="rebase"
ca2cedba 740 ;;
d92a3959
MT
741 --reference)
742 case "$2" in '') usage ;; esac
743 reference="--reference=$2"
98dbe63d
KB
744 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
745 shift
d92a3959
MT
746 ;;
747 --reference=*)
748 reference="$1"
d92a3959 749 ;;
42b49178 750 -m|--merge)
42b49178
JH
751 update="merge"
752 ;;
b13fd5c1 753 --recursive)
b13fd5c1
JH
754 recursive=1
755 ;;
efc5fb6a
JH
756 --checkout)
757 update="checkout"
758 ;;
275cd184
FG
759 --depth)
760 case "$2" in '') usage ;; esac
761 depth="--depth=$2"
762 shift
763 ;;
764 --depth=*)
765 depth=$1
766 ;;
5c08dbbd
JH
767 --)
768 shift
769 break
770 ;;
771 -*)
772 usage
773 ;;
774 *)
775 break
776 ;;
777 esac
98dbe63d
KB
778 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
779 shift
5c08dbbd
JH
780 done
781
d92a3959
MT
782 if test -n "$init"
783 then
784 cmd_init "--" "$@" || return
785 fi
786
1b4735d9 787 cloned_modules=
15ffb7cd
FG
788 module_list "$@" | {
789 err=
64394e3a 790 while read mode sha1 stage sm_path
70c7ac22 791 do
be9d0a3a 792 die_if_unmatched "$mode"
313ee0d6
NMC
793 if test "$stage" = U
794 then
75bf5e60 795 echo >&2 "Skipping unmerged submodule $prefix$sm_path"
313ee0d6
NMC
796 continue
797 fi
64394e3a 798 name=$(module_name "$sm_path") || exit
5be60078 799 url=$(git config submodule."$name".url)
06b1abb5 800 branch=$(get_submodule_config "$name" branch master)
efc5fb6a
JH
801 if ! test -z "$update"
802 then
803 update_module=$update
804 else
805 update_module=$(git config submodule."$name".update)
a2aed08b
TK
806 if test -z "$update_module"
807 then
808 update_module="checkout"
809 fi
efc5fb6a
JH
810 fi
811
091a6eb0
JK
812 displaypath=$(relative_path "$prefix$sm_path")
813
efc5fb6a
JH
814 if test "$update_module" = "none"
815 then
091a6eb0 816 echo "Skipping submodule '$displaypath'"
efc5fb6a
JH
817 continue
818 fi
819
211b7f19 820 if test -z "$url"
70c7ac22
LH
821 then
822 # Only mention uninitialized submodules when its
823 # path have been specified
824 test "$#" != "0" &&
091a6eb0 825 say "$(eval_gettext "Submodule path '\$displaypath' not initialized
1c2ef66f 826Maybe you want to use 'update --init'?")"
211b7f19
LH
827 continue
828 fi
829
64394e3a 830 if ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
211b7f19 831 then
275cd184 832 module_clone "$sm_path" "$name" "$url" "$reference" "$depth" || exit
1b4735d9 833 cloned_modules="$cloned_modules;$name"
bf2d8246
LH
834 subsha1=
835 else
64394e3a 836 subsha1=$(clear_local_git_env; cd "$sm_path" &&
5be60078 837 git rev-parse --verify HEAD) ||
091a6eb0 838 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
70c7ac22 839 fi
211b7f19 840
06b1abb5
TK
841 if test -n "$remote"
842 then
843 if test -z "$nofetch"
844 then
845 # Fetch remote before determining tracking $sha1
846 (clear_local_git_env; cd "$sm_path" && git-fetch) ||
847 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
848 fi
849 remote_name=$(clear_local_git_env; cd "$sm_path" && get_default_remote)
850 sha1=$(clear_local_git_env; cd "$sm_path" &&
851 git rev-parse --verify "${remote_name}/${branch}") ||
852 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
853 fi
854
01d47215 855 if test "$subsha1" != "$sha1" -o -n "$force"
70c7ac22 856 then
9db31bdf
NMC
857 subforce=$force
858 # If we don't already have a -f flag and the submodule has never been checked out
859 if test -z "$subsha1" -a -z "$force"
b9b378a0 860 then
9db31bdf 861 subforce="-f"
b9b378a0 862 fi
31ca3ac3
FF
863
864 if test -z "$nofetch"
865 then
e5f522d6
JL
866 # Run fetch only if $sha1 isn't present or it
867 # is not reachable from a ref.
64394e3a 868 (clear_local_git_env; cd "$sm_path" &&
f5799e05 869 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
e5f522d6 870 test -z "$rev") || git-fetch)) ||
091a6eb0 871 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
31ca3ac3
FF
872 fi
873
1b4735d9
SO
874 # Is this something we just cloned?
875 case ";$cloned_modules;" in
876 *";$name;"*)
877 # then there is no local change to integrate
a2aed08b 878 update_module=checkout ;;
1b4735d9
SO
879 esac
880
877449c1 881 must_die_on_failure=
32948425 882 case "$update_module" in
a2aed08b
TK
883 checkout)
884 command="git checkout $subforce -q"
885 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
886 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
887 ;;
32948425
JH
888 rebase)
889 command="git rebase"
091a6eb0
JK
890 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
891 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
877449c1 892 must_die_on_failure=yes
32948425 893 ;;
42b49178
JH
894 merge)
895 command="git merge"
091a6eb0
JK
896 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
897 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
877449c1 898 must_die_on_failure=yes
42b49178 899 ;;
6cb5728c
CP
900 !*)
901 command="${update_module#!}"
902 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$prefix\$sm_path'")"
903 say_msg="$(eval_gettext "Submodule path '\$prefix\$sm_path': '\$command \$sha1'")"
904 must_die_on_failure=yes
905 ;;
32948425 906 *)
a2aed08b 907 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
32948425 908 esac
70c7ac22 909
64394e3a 910 if (clear_local_git_env; cd "$sm_path" && $command "$sha1")
15ffb7cd 911 then
ff968f03 912 say "$say_msg"
877449c1
JH
913 elif test -n "$must_die_on_failure"
914 then
ff968f03 915 die_with_status 2 "$die_msg"
15ffb7cd 916 else
ff968f03 917 err="${err};$die_msg"
877449c1 918 continue
15ffb7cd 919 fi
70c7ac22 920 fi
b13fd5c1
JH
921
922 if test -n "$recursive"
923 then
75bf5e60
WE
924 (
925 prefix="$prefix$sm_path/"
926 clear_local_git_env
927 cd "$sm_path" &&
928 eval cmd_update "$orig_flags"
929 )
15ffb7cd
FG
930 res=$?
931 if test $res -gt 0
932 then
091a6eb0 933 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
15ffb7cd
FG
934 if test $res -eq 1
935 then
ff968f03 936 err="${err};$die_msg"
15ffb7cd
FG
937 continue
938 else
ff968f03 939 die_with_status $res "$die_msg"
15ffb7cd
FG
940 fi
941 fi
b13fd5c1 942 fi
70c7ac22 943 done
15ffb7cd
FG
944
945 if test -n "$err"
946 then
947 OIFS=$IFS
948 IFS=';'
949 for e in $err
950 do
951 if test -n "$e"
952 then
953 echo >&2 "$e"
954 fi
955 done
956 IFS=$OIFS
957 exit 1
958 fi
959 }
70c7ac22
LH
960}
961
bffe71f4
EM
962set_name_rev () {
963 revname=$( (
74ae1419 964 clear_local_git_env
bffe71f4 965 cd "$1" && {
5be60078
JH
966 git describe "$2" 2>/dev/null ||
967 git describe --tags "$2" 2>/dev/null ||
f669ac0b
ML
968 git describe --contains "$2" 2>/dev/null ||
969 git describe --all --always "$2"
bffe71f4
EM
970 }
971 ) )
972 test -z "$revname" || revname=" ($revname)"
973}
28f9af5d
PY
974#
975# Show commit summary for submodules in index or working tree
976#
977# If '--cached' is given, show summary between index and given commit,
978# or between working tree and given commit
979#
980# $@ = [commit (default 'HEAD'),] requested paths (default all)
981#
982cmd_summary() {
f2dc06a3 983 summary_limit=-1
d0f64dd4 984 for_status=
1c244f6e 985 diff_cmd=diff-index
f2dc06a3 986
28f9af5d
PY
987 # parse $args after "submodule ... summary".
988 while test $# -ne 0
989 do
990 case "$1" in
991 --cached)
992 cached="$1"
993 ;;
1c244f6e
JL
994 --files)
995 files="$1"
996 ;;
d0f64dd4
PY
997 --for-status)
998 for_status="$1"
999 ;;
f2dc06a3 1000 -n|--summary-limit)
862ae6cd
RS
1001 summary_limit="$2"
1002 isnumber "$summary_limit" || usage
f2dc06a3
PY
1003 shift
1004 ;;
862ae6cd
RS
1005 --summary-limit=*)
1006 summary_limit="${1#--summary-limit=}"
1007 isnumber "$summary_limit" || usage
1008 ;;
28f9af5d
PY
1009 --)
1010 shift
1011 break
1012 ;;
1013 -*)
1014 usage
1015 ;;
1016 *)
1017 break
1018 ;;
1019 esac
1020 shift
1021 done
bffe71f4 1022
f2dc06a3
PY
1023 test $summary_limit = 0 && return
1024
3deea89c 1025 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
1026 then
1027 head=$rev
caa9c3ca 1028 test $# = 0 || shift
3deea89c
JH
1029 elif test -z "$1" -o "$1" = "HEAD"
1030 then
14e940d7
JH
1031 # before the first commit: compare with an empty tree
1032 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 1033 test -z "$1" || shift
28f9af5d 1034 else
3deea89c 1035 head="HEAD"
28f9af5d
PY
1036 fi
1037
1c244f6e
JL
1038 if [ -n "$files" ]
1039 then
1040 test -n "$cached" &&
465d6a00 1041 die "$(gettext "The --cached option cannot be used with the --files option")"
1c244f6e
JL
1042 diff_cmd=diff-files
1043 head=
1044 fi
1045
28f9af5d 1046 cd_to_toplevel
091a6eb0 1047 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
28f9af5d 1048 # Get modified modules cared by user
18076502 1049 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 1050 sane_egrep '^:([0-7]* )?160000' |
2be94509 1051 while read mod_src mod_dst sha1_src sha1_dst status sm_path
28f9af5d
PY
1052 do
1053 # Always show modules deleted or type-changed (blob<->module)
2be94509 1054 test $status = D -o $status = T && echo "$sm_path" && continue
927b26f8 1055 # Respect the ignore setting for --for-status.
1056 if test -n "$for_status"
1057 then
1058 name=$(module_name "$sm_path")
1059 ignore_config=$(get_submodule_config "$name" ignore none)
1060 test $status != A -a $ignore_config = all && continue
1061 fi
28f9af5d 1062 # Also show added or modified modules which are checked out
2be94509 1063 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
1064 echo "$sm_path"
28f9af5d
PY
1065 done
1066 )
1cb639e6 1067
d0f64dd4
PY
1068 test -z "$modules" && return
1069
18076502 1070 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 1071 sane_egrep '^:([0-7]* )?160000' |
1cb639e6
PY
1072 cut -c2- |
1073 while read mod_src mod_dst sha1_src sha1_dst status name
1074 do
1075 if test -z "$cached" &&
1076 test $sha1_dst = 0000000000000000000000000000000000000000
1077 then
1078 case "$mod_dst" in
1079 160000)
1080 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
1081 ;;
1082 100644 | 100755 | 120000)
1083 sha1_dst=$(git hash-object $name)
1084 ;;
1085 000000)
1086 ;; # removed
1087 *)
1088 # unexpected type
6ff875c5 1089 eval_gettextln "unexpected mode \$mod_dst" >&2
1cb639e6
PY
1090 continue ;;
1091 esac
1092 fi
1093 missing_src=
1094 missing_dst=
1095
1096 test $mod_src = 160000 &&
30353a40 1097 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
1098 missing_src=t
1099
1100 test $mod_dst = 160000 &&
30353a40 1101 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 1102 missing_dst=t
bffe71f4 1103
091a6eb0
JK
1104 display_name=$(relative_path "$name")
1105
1cb639e6
PY
1106 total_commits=
1107 case "$missing_src,$missing_dst" in
1108 t,)
091a6eb0 1109 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1cb639e6
PY
1110 ;;
1111 ,t)
091a6eb0 1112 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
1113 ;;
1114 t,t)
091a6eb0 1115 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
1116 ;;
1117 *)
1118 errmsg=
1119 total_commits=$(
1120 if test $mod_src = 160000 -a $mod_dst = 160000
1121 then
1122 range="$sha1_src...$sha1_dst"
1123 elif test $mod_src = 160000
1124 then
1125 range=$sha1_src
1126 else
1127 range=$sha1_dst
1128 fi
1129 GIT_DIR="$name/.git" \
b0e621ad 1130 git rev-list --first-parent $range -- | wc -l
1cb639e6 1131 )
eed35595 1132 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
1133 ;;
1134 esac
1135
1136 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
1137 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
1138 if test $status = T
1139 then
b3e73449
ÆAB
1140 blob="$(gettext "blob")"
1141 submodule="$(gettext "submodule")"
1cb639e6
PY
1142 if test $mod_dst = 160000
1143 then
091a6eb0 1144 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 1145 else
091a6eb0 1146 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
1147 fi
1148 else
091a6eb0 1149 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1cb639e6
PY
1150 fi
1151 if test -n "$errmsg"
1152 then
1153 # Don't give error msg for modification whose dst is not submodule
1154 # i.e. deleted or changed to blob
1155 test $mod_dst = 160000 && echo "$errmsg"
1156 else
1157 if test $mod_src = 160000 -a $mod_dst = 160000
1158 then
f2dc06a3
PY
1159 limit=
1160 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 1161 GIT_DIR="$name/.git" \
f2dc06a3 1162 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
1163 --first-parent $sha1_src...$sha1_dst
1164 elif test $mod_dst = 160000
1165 then
1166 GIT_DIR="$name/.git" \
1167 git log --pretty='format: > %s' -1 $sha1_dst
1168 else
1169 GIT_DIR="$name/.git" \
1170 git log --pretty='format: < %s' -1 $sha1_src
1171 fi
1172 echo
1173 fi
1174 echo
3ba7407b 1175 done
28f9af5d 1176}
70c7ac22 1177#
941987a5 1178# List all submodules, prefixed with:
70c7ac22
LH
1179# - submodule not initialized
1180# + different revision checked out
1181#
1182# If --cached was specified the revision in the index will be printed
1183# instead of the currently checked out revision.
1184#
1185# $@ = requested paths (default to all)
1186#
23a485e3 1187cmd_status()
70c7ac22 1188{
5c08dbbd
JH
1189 # parse $args after "submodule ... status".
1190 while test $# -ne 0
1191 do
1192 case "$1" in
1193 -q|--quiet)
2e6a30ef 1194 GIT_QUIET=1
5c08dbbd
JH
1195 ;;
1196 --cached)
1197 cached=1
1198 ;;
64b19ffe
JH
1199 --recursive)
1200 recursive=1
1201 ;;
5c08dbbd
JH
1202 --)
1203 shift
1204 break
1205 ;;
1206 -*)
1207 usage
1208 ;;
1209 *)
1210 break
1211 ;;
1212 esac
1213 shift
1214 done
1215
a7b3269c 1216 module_list "$@" |
64394e3a 1217 while read mode sha1 stage sm_path
70c7ac22 1218 do
be9d0a3a 1219 die_if_unmatched "$mode"
64394e3a 1220 name=$(module_name "$sm_path") || exit
5be60078 1221 url=$(git config submodule."$name".url)
091a6eb0 1222 displaypath=$(relative_path "$prefix$sm_path")
313ee0d6
NMC
1223 if test "$stage" = U
1224 then
1225 say "U$sha1 $displaypath"
1226 continue
1227 fi
64394e3a 1228 if test -z "$url" || ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
70c7ac22 1229 then
64b19ffe 1230 say "-$sha1 $displaypath"
70c7ac22
LH
1231 continue;
1232 fi
64394e3a 1233 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
70c7ac22 1234 then
b545cd15 1235 set_name_rev "$sm_path" "$sha1"
64b19ffe 1236 say " $sha1 $displaypath$revname"
70c7ac22
LH
1237 else
1238 if test -z "$cached"
1239 then
64394e3a 1240 sha1=$(clear_local_git_env; cd "$sm_path" && git rev-parse --verify HEAD)
70c7ac22 1241 fi
b545cd15 1242 set_name_rev "$sm_path" "$sha1"
64b19ffe
JH
1243 say "+$sha1 $displaypath$revname"
1244 fi
1245
1246 if test -n "$recursive"
1247 then
1248 (
1249 prefix="$displaypath/"
74ae1419 1250 clear_local_git_env
64394e3a 1251 cd "$sm_path" &&
e15bec0e 1252 eval cmd_status
64b19ffe 1253 ) ||
64394e3a 1254 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
70c7ac22
LH
1255 fi
1256 done
1257}
2327f61e
DA
1258#
1259# Sync remote urls for submodules
1260# This makes the value for remote.$remote.url match the value
1261# specified in .gitmodules.
1262#
1263cmd_sync()
1264{
1265 while test $# -ne 0
1266 do
1267 case "$1" in
1268 -q|--quiet)
2e6a30ef 1269 GIT_QUIET=1
2327f61e
DA
1270 shift
1271 ;;
82f49f29
PH
1272 --recursive)
1273 recursive=1
1274 shift
1275 ;;
2327f61e
DA
1276 --)
1277 shift
1278 break
1279 ;;
1280 -*)
1281 usage
1282 ;;
1283 *)
1284 break
1285 ;;
1286 esac
1287 done
1288 cd_to_toplevel
1289 module_list "$@" |
64394e3a 1290 while read mode sha1 stage sm_path
2327f61e 1291 do
be9d0a3a 1292 die_if_unmatched "$mode"
64394e3a 1293 name=$(module_name "$sm_path")
2327f61e 1294 url=$(git config -f .gitmodules --get submodule."$name".url)
baede9f8
JH
1295
1296 # Possibly a url relative to parent
1297 case "$url" in
1298 ./*|../*)
967b2c66
JS
1299 # rewrite foo/bar as ../.. to find path from
1300 # submodule work tree to superproject work tree
1301 up_path="$(echo "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1302 # guarantee a trailing /
1303 up_path=${up_path%/}/ &&
1304 # path from submodule work tree to submodule origin repo
1305 sub_origin_url=$(resolve_relative_url "$url" "$up_path") &&
1306 # path from superproject work tree to submodule origin repo
1307 super_config_url=$(resolve_relative_url "$url") || exit
1308 ;;
1309 *)
1310 sub_origin_url="$url"
1311 super_config_url="$url"
baede9f8
JH
1312 ;;
1313 esac
1314
ccee6086 1315 if git config "submodule.$name.url" >/dev/null 2>/dev/null
2327f61e 1316 then
091a6eb0
JK
1317 displaypath=$(relative_path "$prefix$sm_path")
1318 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
967b2c66 1319 git config submodule."$name".url "$super_config_url"
ccee6086 1320
64394e3a 1321 if test -e "$sm_path"/.git
ccee6086
JH
1322 then
1323 (
1324 clear_local_git_env
64394e3a 1325 cd "$sm_path"
ccee6086 1326 remote=$(get_default_remote)
967b2c66 1327 git config remote."$remote".url "$sub_origin_url"
82f49f29
PH
1328
1329 if test -n "$recursive"
1330 then
1331 prefix="$prefix$sm_path/"
1332 eval cmd_sync
1333 fi
ccee6086
JH
1334 )
1335 fi
2327f61e
DA
1336 fi
1337 done
1338}
70c7ac22 1339
5c08dbbd
JH
1340# This loop parses the command line arguments to find the
1341# subcommand name to dispatch. Parsing of the subcommand specific
1342# options are primarily done by the subcommand implementations.
1343# Subcommand specific options such as --branch and --cached are
1344# parsed here as well, for backward compatibility.
1345
1346while test $# != 0 && test -z "$command"
70c7ac22
LH
1347do
1348 case "$1" in
cf419828 1349 add | foreach | init | deinit | update | status | summary | sync)
5c08dbbd 1350 command=$1
70c7ac22
LH
1351 ;;
1352 -q|--quiet)
2e6a30ef 1353 GIT_QUIET=1
70c7ac22 1354 ;;
ecda0723
SV
1355 -b|--branch)
1356 case "$2" in
1357 '')
1358 usage
1359 ;;
1360 esac
1361 branch="$2"; shift
1362 ;;
70c7ac22 1363 --cached)
28f9af5d 1364 cached="$1"
70c7ac22
LH
1365 ;;
1366 --)
1367 break
1368 ;;
1369 -*)
1370 usage
1371 ;;
1372 *)
1373 break
1374 ;;
1375 esac
1376 shift
1377done
1378
5c08dbbd 1379# No command word defaults to "status"
af9c9f97
RR
1380if test -z "$command"
1381then
1382 if test $# = 0
1383 then
1384 command=status
1385 else
1386 usage
1387 fi
1388fi
5c08dbbd
JH
1389
1390# "-b branch" is accepted only by "add"
1391if test -n "$branch" && test "$command" != add
1392then
ecda0723 1393 usage
5c08dbbd
JH
1394fi
1395
28f9af5d
PY
1396# "--cached" is accepted only by "status" and "summary"
1397if test -n "$cached" && test "$command" != status -a "$command" != summary
5c08dbbd 1398then
70c7ac22 1399 usage
5c08dbbd
JH
1400fi
1401
1402"cmd_$command" "$@"